Ruby - Feature #9852

How to bundile test-unit2 and minitest5
05/19/2014 01:26 PM - hsbt (Hiroshi SHIBATA)

Status: Closed

Priority: Normal

Assignee: kou (Kouhei Sutou)
Target version: 2.2.0

Description

| removed test-unit and minitest at #9711
But we need to bundle testing framework with Ruby 2.2.0 continuously.

| hope to bundle test-unit2 and minitest5 with Ruby 2.2.0.
kou

Could you bundle and maintain test-unit2 on CRuby?

ryan
Do you have any idea of gem installation mechanism with packaging?

Related issues:
Related to Ruby - Bug #10610: "make install" fails without zlib Closed 12/17/2014

Associated revisions

Revision 27d345dff4cca902cc4d61057d892aca5fd2d936 - 06/24/2014 01:45 AM - hsbt (Hiroshi SHIBATA)

¢ tool/make-snapshot: download bundle gems when package making.
[Feature #9852][ruby-core:62676]
e gems/bundled_gems: listed bundled gems for Ruby 2.2.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46536 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 27d345df - 06/24/2014 01:45 AM - hsbt (Hiroshi SHIBATA)

¢ tool/make-snapshot: download bundle gems when package making.
[Feature #9852][ruby-core:62676]
¢ gems/bundled_gems: listed bundled gems for Ruby 2.2.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@46536 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/20/2014 10:02 AM - zenspider (Ryan Davis)

Rubygems allows for installation from local gems, so it'd be entirely possible to have the gems contained in the tarball in a directory, and installed
normally. It shouldn't be too much work to make this happen only during packaging time (ie, we don't need to commit the gem binaries to SVN, just a
manifest of what gems/versions we want). | would like this to happen for all of the gems we currently ship internally: rake, minitest, rdoc, etc. Authors,
willing, of course.

| don't know the build system very well, so | don't know all the places I'd have to poke at to make this happen. Suggestions/patches welcome.

| also have the ruby gem. We can use that as a meta-gem that simply declares fixed dependencies on all the gems that ship with that version. If a
user wants to repair their setup, they'd only need to run gem install ruby -v x.y.z.

#2 - 05/24/2014 02:41 AM - kou (Kouhei Sutou)
Hiroshi SHIBATA wrote:

| hope to bundle test-unit2 and minitest5 with Ruby 2.2.0.

Could you explain why you want to bundle test-unit2? It is for providing test-unit API. Right?
https://bugs.ruby-lang.org/issues/9711

(test-unit APl means that API provided by test-unit bundled in Ruby 1.8.)

If you expect that test-unit2 provides 100% compatible test-unit API, unfortunately it is wrong. test-unit2 has some incompatible API changes. For
example, the following test suite shows different behavior:

require "test/unit"

class Parent < Test::Unit::TestCase
def test_parent
p :parent
end

class Child < self
def test_child
p :child
end
end
end

test-unit API (= test-unit gem 1.2.3) runs tests defined in parent test cases:

[

% ruby a.rb
Loaded suite a
Started
:parent
.:child
.iparent

Finished in 0.000207854 seconds.
3 tests, 0 assertions, 0 failures, 0 errors
test-unit2 doesn't run tests defined in parent test cases:

[

% ruby a.rb

Loaded suite a

Started

:parent

.:child

Finished in 0.001269378 seconds.

2 tests, 0 assertions, 0 failures, 0 errors, 0 pendings, 0 omissions, 0 notifications
100% passed

1575.57 tests/s, 0.00 assertions/s
| think that the current test-unit2 behavior is better to write organized tests but it is not suitable for 100% compatible test-unit APl expectation.
So | want you to explain why you want to bundle test-unit2.

kou
Could you bundle and maintain test-unit2 on CRuby?

Yes with reservations. If bundling test-unit2 satisfies your expectation and it doesn't break integratioin with test-unit2 released at RubyGems.org(*), |
say yes.

(*) Users couldn't use test-unit2 gem by gem install test-unit. Users also need to call gem "test-unit" in their code. It was solved by introducing default
gem feature. | don't care about mechanism. It is OK to me that it is solved by other mechanism.

#3 - 05/29/2014 03:17 AM - hsbt (Hiroshi SHIBATA)
- File gem-install-task.patch added
- File gem-install-task.patch added

| implemented gem install task when running with "make install".
This task detect gems from gems directory and install it.

#4 - 05/29/2014 03:17 AM - hsbt (Hiroshi SHIBATA)
- File deleted (gem-install-task.patch)
#5 - 05/29/2014 03:18 AM - hsbt (Hiroshi SHIBATA)
- File deleted (gem-install-task.patch)

#6 - 05/29/2014 03:18 AM - hsbt (Hiroshi SHIBATA)
- File gem-install-task.patch added

#7 - 05/29/2014 03:59 AM - hsbt (Hiroshi SHIBATA)

redmine can't handle my attachments file.
Please see https://github.com/hsbt/ruby/compare/ruby:trunk...bundle-gem

#8 - 06/03/2014 10:59 PM - zenspider (Ryan Davis)

| don't think we need to actually commit the gem files to SVN, but | think your patch is a good start.

We could have a manifest of the gems & versions we want to package and have that be part of the packaging and/or compiling step. With exact
versions specified, we won't need to keep updating "large" binaries in version control.

#9 - 06/18/2014 10:12 AM - hsbt (Hiroshi SHIBATA)

| updated my patch. this patch downloads gems defined in gems/bundle_gems when package making time.

#10 - 06/24/2014 01:45 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset r46536.

e tool/make-snapshot: download bundle gems when package making.
[Feature #9852][ruby-core:62676]
e gems/bundled_gems: listed bundled gems for Ruby 2.2.

#11 - 06/24/2014 02:48 AM - zenspider (Ryan Davis)

May | convert rake & others?

#12 - 06/24/2014 02:53 AM - zenspider (Ryan Davis)

Also, does this not hook into make install?
#13 - 06/24/2014 02:59 AM - akr (Akira Tanaka)
Please don't make network accessibility mandatory for "make install".

1. It makes difficult to develop Ruby when PC is not network accessible.
2. It makes difficult to distinguish (temporal) network failure or other problem in CI.

#14 - 06/24/2014 04:46 AM - zenspider (Ryan Davis)

There needs to be SOME step that a user can take to get a full install. svn co ...; autoconf ; configure ; make install is still our default path and should
wind up with the same thing you'd get from a build from make dist.

I'm sure we can add a new make rule for non-networked development.

#15 - 06/27/2014 12:52 PM - vo.x (Vit Ondruch)

| always had the vision that the gems should be available in source format. Something like svn:externals or git submodules. The sources would be
editable that way, which comes handy at some times. It also avoids the "download" step, since it would be done directly with repository checkout.

#16 - 08/10/2014 10:41 AM - naruse (Yui NARUSE)
- File deleted (gem-install-task.patch)

#17 - 12/17/2014 01:53 PM - vo.x (Vit Ondruch)
- Related to Bug #10610: "make install" fails without zlib added
